export const getNotificationTokenFromServer = async () => {
    const config: AxiosRequestConfig = {
        method: 'GET',
        url: API_URL + `/api/notif-token/${authStore.userId}/`,
        headers: { "Authorization": "Bearer " + authStore.accessToken, }
    }
    
    try {
        const response = await axios(config);   
        return response.data;
    } catch (error) {
        if (error.response.status == 401) {
            try {
                await refreshAccessToken()    
                const response = await axios({...config, headers: { "Authorization": "Bearer " + authStore.accessToken }});   

                return response.data;
            } catch (error) {
                // refreshAccessToken will report errors
            }
        }

        reportAxiosError('Something went wrong when retrieving landmarks', error)
        throw new Error;
    }
}

    const ensureNotificationTokenExistsOnServer = async (notificationToken: string, retries: number) => {
        if (retries > 0) {
            const config: AxiosRequestConfig = {
                method: 'POST',
                data: {token: notificationToken},
                url: API_URL + `/api/notif-token/${authStore.userId}/`,
                headers: { "Authorization": "Bearer " + authStore.accessToken, }
            } 
            try {
                const response = await axios(config);   
                return response.data;
            } catch (error) {
                if (error.response.status == 401) {
                    try {
                        await refreshAccessToken()    
                        const response = await axios({...config, headers: { "Authorization": "Bearer " + authStore.accessToken }});   

                        return response.data;
                    } catch (error) {
                        // refreshAccessToken will report errors
                    }
                }
                reportAxiosError('Something went wrong when retrieving landmarks', error)
            }
    
            ensureNotificationTokenExistsOnServer(notificationToken, retries - 1)   
        }
        else {
            throw new Error;
        }
    }